Attribute VB_Name = "Database"
Option Explicit

'
' D A T A B A S E   R E C O R D I N G
'

'for snapshots
Dim SnapName As String

' creates a new database

Public Sub CreateArchive(Name As String)
  Dim t As Integer
  Open Name For Output As 2
    Print #2, "Rob id,Parent id,Founder name,Generation,Birth cycle,Age,Mutations,New mutations,Dna length,Offspring number,Total pop,Vegs pop,Robs pop,kills";
    For t = 1 To 100
      Print #2, ",gene" & t;
    Next t
    Print #2, "end "
  Close 2
End Sub

' opens a previously created database
Public Sub OpenDB(Name)
  Open Name For Append As 2
  OptionsForm.DBOptsEnable False
End Sub

' closes a db
Public Sub CloseDatabase()
  Close 2
  OptionsForm.DBOptsEnable True
End Sub

Private Sub SnapBrowse() 'creates a file to store the snapshot into
  Form1.CommonDialog1.InitDir = MDIForm1.MainDir + "/database"
  Form1.CommonDialog1.DialogTitle = "Select a name for your snapshot file."
  Form1.CommonDialog1.Filter = "Text Database (*.txt)|*.txt"
  Form1.CommonDialog1.ShowSave
  SnapName = Form1.CommonDialog1.filename
End Sub

Public Sub Snapshot()
  'records a snapshot of all living robots in a snapshot database
  Dim v As String
  Dim t As Integer
  Dim a As String
  Dim d As String
  Dim ti As Integer
  Dim va As Integer
  Dim rn As Integer
  Dim ok As Boolean
  
  On Error GoTo fine
  SnapBrowse
  Open SnapName For Output As 3
  Print #3, "Rob id,Parent id,Founder name,Generation,Birth cycle,Age,Mutations,New mutations,Dna length,Offspring number,Total pop,Vegs pop,Robs pop,kills";
  
  For t = 1 To 100
    Print #3, ",gene" & t;
  Next t
  
  Print #3, "end "
  v = ","
  For rn = 1 To UBound(rob())
    If rob(rn).Veg And SimOpts.DBExcludeVegs Then
      ok = False
    Else
      ok = True
    End If
    If rob(rn).Exist And ok Then
      With rob(rn)
        Print #3, sstr(.AbsNum); v; sstr(.Parent); v; .fname; v; sstr(.generation); v; sstr(.BirthCycle); v; sstr(.age); v; sstr(.Mutations); v;
        Print #3, sstr(.LastMut); v; sstr(.DnaLen); v; sstr(.SonNumber); v; sstr(totalrobots); v; sstr(totvegs); v; sstr(totnvegs); v; sstr(.kills); v;
    
        d = ""
        t = 1
        While True
          If .DNA(t).tipo = 4 And .DNA(t).value = 4 Then Print #3, "end": GoTo endwhile
          ti = .DNA(t).tipo
          va = .DNA(t).value
          Select Case .DNA(t).tipo
          Case 0
            If t + 1 > UBound(.DNA()) Then Print #3, "end": GoTo endwhile
            If .DNA(t + 1).tipo = 2 And .DNA(t + 1).value = 1 Then
              d = d + "  " + varname(va)
            Else
              d = d + " " + Str$(va)
            End If
          Case 1
            a = varname(va)
            d = d + "  " + "*" + a
          Case 2
            Select Case va
              Case 1
                d = d + "  store"
              Case 3
                d = d + "  add"
              Case 4
                d = d + "  sub"
              Case 5
                d = d + "  mult"
              Case 6
                d = d + "  div"
              Case 7
                d = d + "  rnd"
              Case 8
                d = d + "  inc"
              Case 9
                d = d + "  dec"
              Case 10
                d = d + "  angle"
              Case 11
                d = d + "  dist"
              Case 12
                d = d + "  addstore"
              Case 13
                d = d + "  substore"
              Case 14
                d = d + "  divstore"
              Case 15
                d = d + "  multstore"
              Case 16
                d = d + "  mod"
              Case 17
                d = d + "  ceil"
              Case 18
                d = d + "  floor"
              Case 19
                d = d + "  sqr"
              Case 20
                d = d + "  ^"
              Case 21
                d = d + "  sgn"
              Case 22
                d = d + "  abs"
              Case 23
                d = d + "  dup"
              Case 24
                d = d + "  pyth"
            End Select
          Case 3
            Select Case va
              Case 1
                d = d + "  <"
              Case 2
                d = d + "  >"
              Case 3
                d = d + "  ="
              Case 4
                d = d + "  !="
              Case 5
                d = d + "  %="
              Case 6
                d = d + "  !%="
              Case 7
                d = d + "  ~="
              Case 8
                d = d + "  !~="
              Case 9
                d = d + "  >="
              Case 10
                d = d + "  <="
            End Select
          Case 4
            Select Case va
              Case 1
                d = d + ""
                d = d + "cond"
              Case 2
                d = d + " start"
              Case 3
                d = d + " stop"
                Print #3, d; v;
                d = ""
              Case 4
                d = d + "end"
            End Select
          Case 5
            Select Case va
              Case 1
                d = d + " and"
              Case 2
                d = d + " or"
              Case 3
                d = d + " xor"
              Case 4
                d = d + " not"
            End Select
          End Select
          t = t + 1
          If t > UBound(.DNA()) Then Print #3, "end": GoTo endwhile
        Wend
endwhile:
      End With
    End If
  Next rn
  Close 3
  MsgBox ("Saved snapshot successfully.")
Exit Sub
fine:
  Close 3
  If Err.Number = 70 Then
    MsgBox ("That file is already open in another program")
  Else
    d = "File error " + Str$(Err.Number)
    MsgBox (d)
  End If
End Sub

' adds a record
Public Sub AddRecord(rn As Integer)
  Dim v As String
  Dim t As Integer
  Dim a As String
  Dim d As String
  Dim ti As Integer
  Dim va As Integer
  Dim gene As String
  
  On Error GoTo fine
  v = ","
  With rob(rn)
    Print #2, sstr(.AbsNum); v; sstr(.Parent); v; .fname; v; sstr(.generation); v; sstr(.BirthCycle); v; sstr(.age); v; sstr(.Mutations); v;
    Print #2, sstr(.LastMut); v; sstr(.DnaLen); v; sstr(.SonNumber); v; sstr(totalrobots); v; sstr(totvegs); v; sstr(totnvegs); v; sstr(.kills); v;
    
    d = ""
    While True
    If .DNA(t).tipo = 4 And .DNA(t).value = 4 Then Print #2, "end": GoTo endwhile
      ti = .DNA(t).tipo
      va = .DNA(t).value
      Select Case .DNA(t).tipo
      Case 0
        If .DNA(t + 1).tipo = 2 And .DNA(t + 1).value = 1 Then
          d = d + "  " + varname(va)
        Else
          d = d + " " + Str$(va)
        End If
      Case 1
        a = varname(va)
        d = d + "  " + "*" + a
      Case 2
        Select Case va
          Case 1
            d = d + "  store"
          Case 3
            d = d + "  add"
          Case 4
            d = d + "  sub"
          Case 5
            d = d + "  mult"
          Case 6
            d = d + "  div"
          Case 7
            d = d + "  rnd"
          Case 8
            d = d + "  inc"
          Case 9
            d = d + "  dec"
          Case 10
            d = d + "  angle"
          Case 11
            d = d + "  dist"
            Case 12
            d = d + " addstore"
          Case 13
            d = d + " substore"
          Case 14
            d = d + " divstore"
          Case 15
            d = d + " multstore"
          Case 16
            d = d + " mod"
          Case 17
            d = d + " ceil"
          Case 18
            d = d + " floor"
          Case 19
            d = d + " sqr"
          Case 20
            d = d + " ^"
          Case 21
            d = d + " sgn"
          Case 22
            d = d + " abs"
          Case 23
            d = d + " dup"
          Case 24
            d = d + " pyth"
        End Select
      Case 3
        Select Case va
          Case 1
            d = d + "  <"
          Case 2
            d = d + "  >"
          Case 3
            d = d + "  ="
          Case 4
            d = d + "  !="
          Case 5
            d = d + "  %="
          Case 6
            d = d + "  !%="
          Case 7
            d = d + "  ~="
          Case 8
            d = d + "  !~="
          Case 9
            d = d + "  >="
          Case 10
            d = d + "  <="
        End Select
      Case 4
        Select Case va
          Case 1
            d = d + ""
            d = d + "cond"
          Case 2
            d = d + " start"
          Case 3
            'gn = gn + 1
            d = d + " stop"
            Print #2, d; v;
            d = ""
          Case 4
            d = d + "end"
        End Select
      Case 5
        Select Case va
          Case 1
            d = d + "and"
          Case 2
            d = d + " or"
          Case 3
            d = d + " xor"
          Case 4
            d = d + "not"
        End Select
      End Select
      'd = d + vbCrLf
    't = t + 1
  Wend
endwhile:
 End With
 Exit Sub
fine:
  d = "File error " + Str$(Err.Number)
  'MsgBox (d)
  If Err.Number = 70 Then
    MsgBox ("The Database file is already open in another program")
  Else
    MsgBox (d)
  End If
End Sub

' when I wasn't aware of the existence of CStr()
Private Function sstr(x) As String
  sstr = right(Str(x), Len(Str(x)) - 1)
End Function
